<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****
#
# 
#

class cc
{

 //cc rdf var
 var $cc_rdf;
 
 //Work vars
 var $cc_project_name;
 var $cc_date;
 var $cc_description;
 var $cc_maintainer_name;
 var $cc_rights_name;
 var $cc_creation_type;
 var $cc_project_url;
 var $cc_license_filename;
  
 //License vars
 var $cc_rule_permits;
 var $cc_rule_requires;
 var $cc_rule_prohibits;
 
 //Both Work and License
  var $cc_license_url;
 
 /*constructor*/
 function cc($encoding='UTF-8')
 {
   $this->encoding = $encoding;
 }
  
/*setter functions */

 function set_cc_license_permits($cc_permits)
 {
   $this->cc_rule_permits = $cc_permits;
 }
 
 function set_cc_license_prohibits($cc_prohibits)
 {
   $this->cc_rule_prohibits = $cc_prohibits;
 }
 
 function set_cc_license_requires($cc_requires)
 {
   $this->cc_rule_requires = $cc_requires;
 }
 
 function set_cc_maintainer_name($cc_maintainer_name)
 {
    $this->cc_maintainer_name = $cc_maintainer_name;
 }
 
 function set_cc_rights_name($cc_rights_name)
 {
    $this->cc_rights_name = $cc_rights_name;
 }
 
 function set_cc_project_url($cc_project_url)
 {
    $this->cc_project_url = $cc_project_url;
 }
 function set_cc_project_name($cc_name)
 {
    $this->cc_project_name = $cc_name;
 }
 function set_cc_description($cc_description)
 {
    $this->cc_description = $cc_description;
 }
 
 function set_cc_date_project($cc_date)
 {
    $this->cc_date = $cc_date;
 }
 
 function set_cc_creation_type($cc_creation_type)
 {
    $this->cc_creation_type = $cc_creation_type;
 }
 
 function set_cc_license_url($cc_license_url)
 { 
    $this->cc_license_url = $cc_license_url;
 }
 
 function set_cc_filename($cc_filename)
 {
    $this->cc_license_filename = $cc_filename;
 }
 
/*getter functions*/

  /*cc_ouput_headers*/
  function get_cc_output_xml_header()
  {
      return  "<?xml version=\"1.0\" encoding=\"" . $this->encoding ."\"?>\n";		   
  }
  
  function get_cc_output_header_ns()
  {
    $result  ="<rdf:RDF xmlns=\"http://web.resource.org/cc/\"\n";
    $result .="xmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n";
    $result .="xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\">\n";     
                
   return $result;   
  }
  
/*cc_ouput_end*/ 
  function get_cc_output_end()
  {   
      return "</rdf:RDF>";  
  }
  
/*cc_output_Work*/
  function get_cc_output_Work()
  {
    $result  ="<Work rdf:about=\"\">\n";
    $result .="\t<dc:title>".$this->cc_project_name."</dc:title>\n";
    $result .="\t<dc:date>".$this->cc_date."</dc:date>\n";
    $result .="\t<dc:description>".$this->cc_description."</dc:description>\n";
    $result .="\t<dc:creator><Agent>\n";
    $result .="\t\t<dc:title>".$this->cc_maintainer_name."</dc:title>\n";
    $result .="\t</Agent></dc:creator>\n";
    $result .="\t<dc:rights><Agent>\n";
    $result .="\t\t<dc:title>".$this->cc_rights_name."</dc:title>\n";
    $result .="\t</Agent></dc:rights>\n";
    
    if($this->cc_creation_type != '')
    {   
     $result .="\t<dc:type rdf:resource=\"".$this->cc_creation_type."\" />\n";
    }
    
    $result .="\t<dc:source rdf:resource=\"".$this->cc_project_url."\" />\n";
    $result .="\t<license rdf:resource=\"".$this->cc_license_url."\" />\n";
    $result .="</Work>\n";
    
    return $result;
  }

/*cc_output_License*/
  function get_cc_output_License()
  {
    $arry_permits = $this->cc_rule_permits;
    $arry_requires = $this->cc_rule_requires;
    $arry_prohibits = $this->cc_rule_prohibits;
    
    $result  ="<License rdf:about=\"".$this->cc_license_url."\">\n";
               
    if(is_array($arry_permits) && !empty($arry_permits))    
    {
     foreach($arry_permits as $permissions)
     {
      $result .="\t<permits rdf:resource=\"".$permissions."\" />\n";
     }
    }
        
    if(is_array($arry_requires) && !empty($arry_requires))    
    {
     foreach($arry_requires as $requests)
     {
      $result .="\t<requires rdf:resource=\"".$requests."\" />\n";
     }
    }
    
    if($arry_prohibits != null || $arry_prohibits != '')    
    {
      $result .="\t<prohibits rdf:resource=\"".$arry_prohibits."\" />\n" ;
    }    
    
    $result .="</License>\n";
    
    return $result;
  
  } 
    
   function get_output_all_cc()
   {   
      $cc_value  = $this->get_cc_output_xml_header();
      $cc_value .= $this->get_cc_output_header_ns();
      $cc_value .= $this->get_cc_output_Work();
      $cc_value .= $this->get_cc_output_License();
      $cc_value .= $this->get_cc_output_end();
      
    return $cc_value;  
   }
  
  function _generateFilename() 
  {
     return $_SERVER["PHP_SELF"].'./license.rdf';
  }
	
  function save_cc_file($filename='',$cc_rdf)
  {
    if ($filename=="") {
	$filename = $this->_generateFilename();
	}
    
     $ccFile = fopen($filename, "w+");
     
     if ($ccFile) {
		      fputs($ccFile,$cc_rdf);
		      fclose($ccFile);
	            } else {
			$err='<br /><b>Error creating cc file, please check write permissions.</b><br />';
		    }
   }  
  
  
  function save_cc_files($file_array,$cc_rdf)
  {
    if (empty($filename)) {
	  return false;
	}
    
    foreach($file_array as $filename)
    {
      $ccFile = fopen($filename, "w+");
     
      if ($ccFile) {
		      fputs($ccFile,$cc_rdf);
		      fclose($ccFile);
	            } else {
			$err='<br /><b>Error creating cc file, please check write permissions.</b><br />';
		    }
     }
   }
   
   function delete_cc_file($filename='')
   {
      if (is_file($filename)) 
      {   
      return unlink($filename);
      }
   }	
}

?>
