<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****
#
# contributor : Harisson 
#

require_once ('class.cc.php');

class dcCC
{
  var $user_cc_id;
  var $con;
  var $encoding;
  var $cc_mode;
  
  var $cc_filename;
  var $cc_dir;
  
  var $arry_license_permits = array('rp'=>'http://web.resource.org/cc/Reproduction',
                                'di'=>'http://web.resource.org/cc/Distribution',
			        'dw'=>'http://web.resource.org/cc/DerivativeWorks');

  var $arry_license_requires = array('at'=>'http://web.resource.org/cc/Attribution',
                                 'nc'=>'http://web.resource.org/cc/Notice',
			         'sa'=>'http://web.resource.org/cc/ShareAlike');

  var $arry_license_prohibits = 'http://web.resource.org/cc/CommercialUse';
  
  //array representation of the license type url
  var $arry_license_type = array('net'   =>'http://purl.org/dc/dcmitype/Interactive',
                                 'blog'  =>'http://purl.org/dc/dcmitype/Interactive',
                                 'audio' =>'http://purl.org/dc/dcmitype/Sound',
				 'video' =>'http://purl.org/dc/dcmitype/MovingImage',
				 'image' =>'http://purl.org/dc/dcmitype/StillImage',
				 'text'  =>'http://purl.org/dc/dcmitype/Text',
				 'none'  =>'');
  
 //constructor
 
 function dcCC($encoding,$user_cc_id = '',$user_cc_dir = '',$user_cc_mode='add')
 {             
   $this->encoding = $encoding;                 
   $this->user_cc_id  = $user_cc_id;
   $this->cc_dir = $user_cc_dir;
   $this->cc_mode = $user_cc_mode;
 }
 
 function _retrieveData()
 { 
   global $con,$rs_cc;
   
   $cc_content ='';
   $cc_license_base_url='http://creativecommons.org/licenses/';
   $cc_license_version ='/2.0/';
      
   $rs_cc = $con->select('SELECT * FROM '.DB_PREFIX.'cc WHERE user_cc_id ="'.$this->user_cc_id.'"');
       
 if($con->error() === false || !$rs_cc->isEmpty())
 {                        
       $cc_data = $rs_cc->getData();
       //print_r($rs_cc); 
       //print_r($projects);
       $projects = $cc_data[0];
        
       $cc_lang = (htmlspecialchars($projects['user_cc_jurisdiction']) != '')?htmlspecialchars($projects['user_cc_jurisdiction']).'/deed.'.
                  htmlspecialchars($projects['user_cc_jurisdiction']):'';
                     
       $cc = new cc($this->encoding);
       
       //$cc->set_cc_jurisdiction($projects['user_cc_jurisdiction']);
       $cc->set_cc_project_name($projects['user_cc_project_name']);
       $cc->set_cc_filename($projects['user_cc_license_filename']);
                     
       $project_type = $projects['user_cc_license_type'];
              
       $cc->set_cc_creation_type($this->arry_license_type[$project_type]);
       
       $terms = $projects['user_cc_license_terms'];
       
       switch($terms)
       {
         case 'by':
         {	
	     $cc->set_cc_license_url($cc_license_base_url.'by'.$cc_license_version.$cc_lang);
             $cc->set_cc_license_permits($this->arry_license_permits);             
             $cc->set_cc_license_requires(array_slice($this->arry_license_requires,0,2));
             break;
         }	
	 case 'bynd':
         {
	     $cc->set_cc_license_url($cc_license_base_url.'by-nd'.$cc_license_version.$cc_lang);
             $cc->set_cc_license_permits(array_slice($this->arry_license_permits,0,2));             
             $cc->set_cc_license_requires(array_slice($this->arry_license_requires,0,2));
             break;
         }
         case 'byncnd':
         {
	     $cc->set_cc_license_url($cc_license_base_url.'by-nc-nd'.$cc_license_version.$cc_lang);
	     $cc->set_cc_license_permits(array_slice($this->arry_license_permits,0,2));             
             $cc->set_cc_license_requires(array_slice($this->arry_license_requires,0,2));
             $cc->set_cc_license_prohibits($this->arry_license_prohibits);
             break;
         }
         case 'bync':
         {	
	     $cc->set_cc_license_url($cc_license_base_url.'by-nc'.$cc_license_version.$cc_lang);
             $cc->set_cc_license_permits($this->arry_license_permits);             
             $cc->set_cc_license_requires(array_slice($this->arry_license_requires,0,2));
	     $cc->set_cc_license_prohibits($this->arry_license_prohibits);
             break;
         }
         case 'byncsa':
         {    
	     $cc->set_cc_license_url($cc_license_base_url.'by-nc-sa'.$cc_license_version.$cc_lang);        
	     $cc->set_cc_license_permits($this->arry_license_permits);             
             $cc->set_cc_license_requires($this->arry_license_requires);
	     $cc->set_cc_license_prohibits($this->arry_license_prohibits);
             break;
         }
         case 'bysa':
         {      
             $cc->set_cc_license_url($cc_license_base_url.'by-sa'.$cc_license_version.$cc_lang);
             $cc->set_cc_license_permits($this->arry_license_permits);             
             $cc->set_cc_license_requires($this->arry_license_requires);
             break;
         }
	       
       }
                         
       $date_project  = strtotime(trim($projects['user_cc_project_date']));
       $cc->set_cc_date_project(date('Y-m-d',$date_project));
       
       $cc->set_cc_description($projects['user_cc_project_description']);                
       $cc->set_cc_maintainer_name($projects['user_cc_maintainer_name']);
       $cc->set_cc_rights_name($projects['user_cc_rights_name']);  
       $cc->set_cc_project_url($projects['user_cc_project_url']);
       
       $cc->cc_rdf = $cc->get_output_all_cc();
       
       $this->cc_filename = $this->cc_dir . '/' .'license-'.$cc->cc_license_filename.'.rdf';
       
       if($this->cc_mode === 'add')
       {       
         if($this->encoding == 'UTF-8' || $this->encoding == 'utf-8')
         {
           $cc_content = utf8_encode($cc->cc_rdf);   
       
         }else{
   
           $cc_content = $cc->cc_rdf;
         }
              	
         $cc->save_cc_file($this->cc_filename,$cc_content);
         
       } 
       else
       {
         $this->_eraseCCFile($this->cc_filename);
           
            if($this->encoding == 'UTF-8' || $this->encoding == 'utf-8')
            {
              $cc_content = utf8_encode($cc->cc_rdf);   
       
            }else{
   
              $cc_content = $cc->cc_rdf;
            }
              	
           $cc->save_cc_file($this->cc_filename,$cc_content);
       }
                                                   
  }else{
   
   print_r($rs_cc); //debug
   $errors ='<div class="erreur"><p><strong>' . __('cc File(s) creation Error(s)') .$con->error().' :</strong></p>' . '</div>'; 
  }
 }
 
 //delete the cc File with the name license-cc_name_project.rdf
 
 function _eraseCCFile($filename)
 {     
   if (is_file($this->cc_dir . '/' .$filename))  
      return unlink($this->cc_dir . '/' .$filename);
 }
}
?>
